JSB.newAddon = function(mainPath){
  JSB.require('TipViewController');
  var newAddonClass = JSB.defineClass('AutoTipAddon : JSExtension', /*Instance members*/{
    //Window initialize
    sceneWillConnect: function() {
        self.tipController = TipViewController.new();
    },
    //Window disconnect
    sceneDidDisconnect: function() {
    },
    //Window resign active
    sceneWillResignActive: function() {
    },
    //Window become active
    sceneDidBecomeActive: function() {
    },
    notebookWillOpen: function(notebookid) {
      NSNotificationCenter.defaultCenter().addObserverSelectorName(self,'onPopupMenuOnNote:','PopupMenuOnNote');
      NSTimer.scheduledTimerWithTimeInterval(0.2,false,function(){
        var tip_on = NSUserDefaults.standardUserDefaults().objectForKey('marginnote_tip_on');
        if(Application.sharedInstance().studyController(self.window).studyMode < 3 && tip_on == true){// Not support in card deck mode
          Application.sharedInstance().studyController(self.window).view.addSubview(self.tipController.view);
          self.layoutTipController();
          Application.sharedInstance().studyController(self.window).refreshAddonCommands();
          NSTimer.scheduledTimerWithTimeInterval(0.2,false,function(){ 
            Application.sharedInstance().studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
          });
        }
      });
    },
    notebookWillClose: function(notebookid) {
      self.webController.view.removeFromSuperview();  
      NSNotificationCenter.defaultCenter().removeObserverName(self,'PopupMenuOnNote');
      NSNotificationCenter.defaultCenter().removeObserverName(self,'PopupMenuOnSelection');
    },
    documentDidOpen: function(docmd5) {
    },
    documentWillClose: function(docmd5) {
    },
    controllerWillLayoutSubviews: function(controller) {
      if(controller == Application.sharedInstance().studyController(self.window)){
          self.layoutTipController();
      }
    },
    queryAddonCommandStatus: function() {
      if(Application.sharedInstance().studyController(self.window).studyMode < 3)
        return {image:'tip.png',object:self,selector:'autoTip:',checked:(self.tipController.view.window?true:false)};
      return null;
    },
    //Clicking note
    onPopupMenuOnNote: function(sender){
      if(!Application.sharedInstance().checkNotifySenderInWindow(sender,self.window))return;//Don't process message from other window
      if(!self.tipController.view.window)return;
      var text = sender.userInfo.note.allNoteText();
      if(text && text.length){ //加不加没什么意义，留着吧

        if(self.tipController.navigationItem.title == "") return;
       // Application.sharedInstance().showHUD(self.tipController.navigationItem.title,self.window,2);
        var str = "#" + self.tipController.navigationItem.title;
        var flag = true;
        var comments = sender.userInfo.note.comments;
        var existindex = -1;
        for(var i =0;i<comments.length;i++)
        {
        //  Application.sharedInstance().showHUD(comments[i] + ";" + comments[i].value + ";" + comments[i].text + ";" + str,self.window,2);
          if(comments[i].text==str)
          {
           //如果去除多条不加锁的情况话会闪退，因此只记录最一条已存在的标签数据了
           existindex = i;
           flag = false;
          }
        }
        if(existindex != -1)
        {
          sender.userInfo.note.removeCommentByIndex(existindex);
        }
       else
       {
        sender.userInfo.note.appendTextComment(str);
      
       }
       Application.sharedInstance().refreshAfterDBChanged();
      }
    },
    
    autoTip: function(sender) {
      if(self.tipController.view.window){
        self.tipController.view.removeFromSuperview();
        NSUserDefaults.standardUserDefaults().setObjectForKey(false,'marginnote_tip_on');
      }
      else{
        Application.sharedInstance().studyController(self.window).view.addSubview(self.tipController.view);        
        self.layoutTipController();
        NSUserDefaults.standardUserDefaults().setObjectForKey(true,'marginnote_tip_on');
        NSTimer.scheduledTimerWithTimeInterval(0.2,false,function(){ 
          Application.sharedInstance().studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
        });
      }
      Application.sharedInstance().studyController(self.window).refreshAddonCommands();
    },
  }, /*Class members*/{
    addonDidConnect: function() {
    },
    addonWillDisconnect: function() {
    },
    applicationWillEnterForeground: function() {
    },
    applicationDidEnterBackground: function() {
    },
    applicationDidReceiveLocalNotification: function(notify) {
    },
  });
  newAddonClass.prototype.layoutTipController = function(){
    var frame = Application.sharedInstance().studyController(this.window).view.bounds;
    var width = frame.width > 30?(30 + (frame.width - 30)/2):30;
    this.tipController.view.frame = {x:(frame.width-width - 50),y:10,width:width/2,height:30};
  };
  return newAddonClass;
};

